const bodyHtml = $('html,body')

const checkTableScroll = () => {
    let scrollTables = $('.scroll-table')
    if (scrollTables.length) {
        scrollTables.each((index, item) => {
            let _scrollTable = $(item)
            let childTable = _scrollTable.find('table')
            if (_scrollTable.outerWidth() < childTable.outerWidth()) {
                _scrollTable.addClass('scroll-table--show-notice')
            } else {
                _scrollTable.removeClass('scroll-table--show-notice')
            }
        })
    }
}

$(document).on('click', '.lightbox__close, .lightbox__bg, .lightbox__close-btn, .gtl_section_fund, [data-qrcode-validate]', function (e) {
    let targetEle = $(e.currentTarget)
    let targetLightbox = targetEle.parents('.lightbox')
    targetLightbox.removeClass('active')
    targetLightbox.scrollTop(0)
    
    setTimeout(() => {
        targetLightbox.removeClass('before-active')
        bodyHtml.css('overflow', 'initial')
    }, 600)

    // url hash 清空
    let noHashURL = window.location.href.replace(/#.*$/, '');
    window.history.replaceState('', document.title, noHashURL) 

    // 清空 YT 影片
    if($('.lightbox__YT_container')){
        $('.lightbox__YT_container').html('')
    }
})
$(document).on('click', '.open-lightbox-btn', function (e) {
    let targetEle = $(e.currentTarget)
    let targetLightbox = $(targetEle.data('target'))
    let yt_id = targetEle.data('yt-id')
    targetLightbox.addClass('before-active')
    bodyHtml.css('overflow', 'hidden')
    checkTableScroll()
    setTimeout(() => {
        targetLightbox.addClass('active')
    }, 30)

    // url 加上 lightboxID hash
    window.location.hash = targetEle.data('target');
    
    // YT 換影片 ID
    if(targetEle.data('yt-id')){
        $('.lightbox__YT_container').html(`
            <lite-youtube videoid="${yt_id}"></lite-youtube>
        `)
    }
})

// 依照網址的 hash 值來判斷是否要開啟 lightbox
if (window.location.hash && $(`${window.location.hash}.lightbox`).length) {
    let targetLightbox = $(window.location.hash)
    targetLightbox.addClass('before-active')
    bodyHtml.css('overflow', 'hidden')
    setTimeout(() => {
        targetLightbox.addClass('active')
    }, 30)
}

// 將關閉lightbox的按紐，改用<button>
function closeLightbox() {
    const targetLightbox = document.querySelector('.lightbox.active');
    if (targetLightbox) {
        targetLightbox.classList.remove('active');
        targetLightbox.scrollTop = 0;

        setTimeout(() => {
            targetLightbox.classList.remove('before-active');
            document.body.style.overflow = 'initial';
        }, 600);

        // url hash 清空
        const noHashURL = window.location.href.replace(/#.*$/, '');
        window.history.replaceState('', document.title, noHashURL);

        // 清空 YT 影片
        const ytContainer = document.querySelector('.lightbox__YT_container');
        if (ytContainer) {
            ytContainer.innerHTML = '';
        }
    }
}
